
! This module reads in an intermolecular PES parameter file generated by autoPES,
!    and evaluates the fit energy.

module force_field_gen
  use double
  use const
  use utility
  use dimer
  implicit none
  
  ! Parameter type indices
  integer, private, parameter :: T_alpha = 1, T_beta = 2, T_an = 3, T_ainter = 4, T_aintra = 5
  
  integer, private, parameter :: CR_ALPHA=CR_ARITH, CR_BETA=CR_ARITH, CR_LIN=CR_ARITH, CR_CN=CR_GEO
  
  real(8), allocatable :: stcharge(:), pz(:)
  real(8), allocatable :: alpha(:), beta(:), delta1(:), deltap(:), deltan(:,:)
  real(8), allocatable :: a(:,:), C(:,:), A12(:)
  real(8), allocatable :: aMInter(:,:,:), aMIntra(:,:,:)
  real(8), allocatable :: p(:,:,:,:,:), D(:,:,:,:,:)
  real(8), allocatable :: interDist0(:)
  integer, private :: comModeExp, comModeLin
  integer :: oPoly, nDisp, cStart, npterm, ndterm, OPMInter, OPMIntra
  integer, private :: nparm
  logical :: incPol, incElsDmp, incPolDmp, incCore, flexAsym
  
contains


! Evaluate energy components
function energy_ff_gen()
  use polarization
  
  real(8) :: energy_ff_gen(n_FF_comp)
  integer :: sp(2), sptype
  real(8) :: enerij(n_FF_comp), rAB(nsitemax,nsitemax), rABIntra(2,nsitemax,nsitemax)
  integer :: i, j, k
  
  do i = 1,nsite(1)
     do j = 1,nsite(2)
        rAB(i,j) = sqrt( &
             (sit(1,i,1) - sit(2,j,1))**2 + &
             (sit(1,i,2) - sit(2,j,2))**2 + &
             (sit(1,i,3) - sit(2,j,3))**2)
     enddo
  enddo
  if (OPMIntra > 0 .or. OPMInter > 0 .or. flexAsym) then
     do i = 1,2
        do j = 1,nsite(i)
           do k = j,nsite(i)
              sptype = typeMap(stype(i,j),stype(i,k))
              rABIntra(i,j,k) = sqrt( &
                   (sit(i,j,1) - sit(i,k,1))**2 + &
                   (sit(i,j,2) - sit(i,k,2))**2 + &
                   (sit(i,j,3) - sit(i,k,3))**2) - interDist0(sptype)
              rABIntra(i,k,j) = rABIntra(i,j,k)
           enddo
        enddo
     enddo
  endif
  
  ! Evaluate 2-body potential
  energy_ff_gen(:) = 0.0d0
  do i = 1,nsite(1)
     do j = 1,nsite(2)
        sp = [i,j]
        sptype = typeMap(stype(1,i),stype(2,j))
        enerij = energy_ff_gen_ij(sptype, rAB(i,j), sp, rAB, rABIntra)
        do k = 1,n_FF_comp
           energy_ff_gen(k) = energy_ff_gen(k) + enerij(k)
        enddo
     enddo
  enddo
  
  ! Evaluate many-body potential
  if (incPol) energy_ff_gen(F_pol) = polEnergy(MAX_POL_ITER, stcharge, pz, delta1, deltap)
end function energy_ff_gen


! Evaluate contribution of given site-pair type at distance r of two-body potential
! The optional arguments are required only in the case that flexible fit is used
function energy_ff_gen_ij(sptype, r, sp, rmat, rmatIntra)
  
  real(8) :: energy_ff_gen_ij(n_FF_comp)
  integer, intent(in) :: sptype
  real(8), intent(in) :: r
  real(8), intent(in) :: rmat(:,:), rmatIntra(:,:,:)
  integer, intent(in) :: sp(2)
  real(8) :: Eexp, Evdw, Epol, Eels
  real(8) :: sum, rPow, rInv, rInv2, scharge(2), Cval, sCval(2)
  integer :: index, imon, sit1, sit2, sptype2
  integer :: i, j, k
  
  Eexp = 0.0d0
  Evdw = 0.0d0
  Eels = 0.0d0
  
  rInv = 1.0d0/r
  rInv2 = rInv*rInv
  
  ! Compute electrostatic energy
  do imon = 1,2
     scharge(imon) = stcharge(stype(imon,sp(imon)))
     !write(*,*) imon,scharge(imon),typeMapInv(sptype,imon)
     if (npterm > 0) then
        ! Loop only over atoms because fit_asymp is only fitting to atomic intra site-site distances
        do i = 1,natom(imon)
           do j = i+1,natom(imon)
              rPow = 1.0d0
              do k = 1,npterm
                 rPow = rPow*rmatIntra(imon,i,j)
                 scharge(imon) = scharge(imon) + p(imon,sp(imon),i,j,k)*rPow
!                 write(*,'(3I5,3E)') i,j,k,rpow,scharge(imon),p(imon,sp(imon),i,j,k)
              enddo
           enddo
        enddo
     endif
  enddo
  !write(*,'(2I5,4E)') sp(1), sp(2), r, scharge(1), scharge(2)
  Eels = Eels + TT(1, delta1(sptype), r)*scharge(1)*scharge(2)*rInv*h2kcal
  
  ! Compute short-range energy
  Eexp = Eexp + A12(sptype)*rInv2**6
  if (beta(sptype) > 0.0d0) then
     sum = 1.0d0
     
     rPow = 1.0d0
     do i = 1,oPoly
        rPow = rPow*r
        sum = sum + rPow*a(i,sptype)
     enddo
     
     if (OPMInter > 0 .or. OPMIntra > 0) then
        do imon = 1,2
           do j = 1,nsite(imon)
              if (j /= sp(imon)) then
                 
                 if (OPMInter > 0) then
                    if (imon == 1) then
                       sit1 = j
                       sit2 = sp(2)
                    else
                       sit1 = sp(1)
                       sit2 = j
                    endif
                    sptype2 = typeMap(stype(1,sit1),stype(2,sit2))
                    rPow = 1.0d0
                    do k = 1,OPMInter
                       rPow = rPow*rmat(sit1,sit2)
                       sum = sum + rPow*aMInter(k,sptype,sptype2)
                    enddo
                 endif
                 
                 if (OPMIntra > 0) then
                    sptype2 = typeMap(stype(imon,sp(imon)),stype(imon,j))
                    rPow = 1.0d0
                    do k = 1,OPMIntra
                       rPow = rPow*rmatIntra(imon,sp(imon),j)
                       sum = sum + rPow*aMIntra(k,sptype,sptype2)
                    enddo
                 endif
                 
              endif
           enddo
        enddo
     endif
     
     Eexp = Eexp + sum*exp(alpha(sptype) - beta(sptype)*r)
  endif
  
  ! Compute ind+disp energy
  rPow = rInv2**((cStart - 2)/2)
  do i = 1,nDisp
     rPow = rPow*rInv2
     if (ndterm > 0) then
        do imon = 1,2
           index = stype(imon,sp(imon))
           sCval(imon) = C(typeMap(index,index),i) 
           do j = 1,natom(imon)
              do k = j+1,natom(imon)
                 sCval(imon) = sCval(imon) + D(imon,sp(imon),j,k,i)*rmatIntra(imon,j,k)
              enddo
           enddo
        enddo
        Cval = combine(sCval(1), sCval(2), CR_CN)
     else
        Cval = C(sptype,i)
     endif
     Evdw = Evdw - TT(cStart + 2*(i-1), deltan(sptype,i), r)*Cval*rPow
  enddo
  
  energy_ff_gen_ij(F_exp) = Eexp
  energy_ff_gen_ij(F_els) = Eels
  energy_ff_gen_ij(F_vdw) = Evdw
  energy_ff_gen_ij(F_pol) = 0.0d0
  return
end function energy_ff_gen_ij


! Read in PES information from given file
! Ignores redundant info already read from dimer file
subroutine read_fit_gen(filename)
  use dimer 
  
  character(*), intent(in) :: filename
  
  integer :: i, j
  integer :: ncol, index, index2, index3, index4, nParmPerSpt
  integer :: stype1, stype2, stype3, stype4, sptype, sptype2
  integer :: nsptype_in, nOACoor, nline
  real(8) :: val, rBuf(100)
  real(8) :: OACoor(2,MAX_NIDOF)
  character(1000) :: line
  
  if (allocated(stcharge)) then
     deallocate(stcharge,pz)
     deallocate(alpha,beta,delta1,deltap,deltan,C,a,A12)
  endif
  if (allocated(aMInter)) deallocate(aMInter)
  if (allocated(aMIntra)) deallocate(aMIntra)
  
  open(100,file=filename,status='old')
  
  read(100,*) oPoly, nDisp, cStart, OPMInter, OPMIntra
  read(100,'(A)') line
  
  do i = 1,2
     read(100,'(A)') line
  enddo
  
  OACoor(:,:) = 0.0d0
  read(100,*) nOACoor
  do i = 1,nOACoor
     read(100,*) index, index2, val
     OACoor(index,index2) = val
  enddo
  call setOACoor(OACoor)
  
  allocate( stcharge(nstype), pz(nstype) )
  
  incElsDmp = .false.
  incPol = .false.
  incPolDmp = .false.
  incCore = .false.
  do i = 1,nstype
     read(100,*) rBuf(1),rBuf(2)
     stcharge(i) = rBuf(1)
     pz(i) = rBuf(2)
     if (pz(i) > 1.0d-20) incPol = .true.
  enddo
  
  read(100,*) nsptype_in
  
  allocate( alpha(nsptype), beta(nsptype), delta1(nsptype), deltap(nsptype) )
  allocate( deltan(nsptype,nDisp), C(nsptype,nDisp) )
  allocate( a(oPoly,nsptype) )
  allocate( A12(nsptype) )
  
  nParmPerSpt = 1 + 1 + oPoly + nDisp + 1 + 1 + nDisp
  if (incPol) nParmPerSpt = nParmPerSpt + 1
  
  do i = 1,nsptype_in
     read(100,*) stype1, stype2, rBuf(1:nParmPerSpt)
     sptype = typeMap(stype1,stype2)
     
     index = 1
     beta(sptype) = rBuf(index)*bohr2A
     index = index + 1
     alpha(sptype) = rBuf(index)
     index = index + 1
     do j = 1,oPoly
        a(j,sptype) = rBuf(index)*bohr2A**j
        index = index + 1
     end do
     do j = 1,nDisp
        C(sptype,j) = rBuf(index)*A2bohr**(cstart + 2*(j-1))
        index = index + 1
     enddo
     A12(sptype) = rBuf(index)*A2bohr**12
     if (abs(A12(sptype)) > 1.0d-10) incCore = .true.
     index = index + 1
     delta1(sptype) = rBuf(index)*bohr2A
     if (delta1(sptype) < 1.0d3) incElsDmp = .true.
     index = index + 1
     do j = 1,nDisp
        deltan(sptype,j) = rBuf(index)*bohr2A
        index = index + 1
     enddo
     if (incPol) then
        deltap(sptype) = rBuf(index)*bohr2A
        if (deltap(sptype) < 1.0d3) incPolDmp = .true.
        index = index + 1
     endif
  enddo
  
  allocate( interDist0(nsptype) )
  interDist0(:) = 0.0d0
  read(100,*,END=1001) nline
  do i = 1,nline
     read(100,*) stype1, stype2, rbuf(1)
     interDist0(typeMap(stype1,stype2)) = rbuf(1)*A2bohr
  enddo
  
  allocate( aMInter(OPMInter,nsptype,nsptype) )
  aMInter(:,:,:) = 0.0d0
  allocate( aMIntra(OPMIntra,nsptype,nsptype) )
  aMIntra(:,:,:) = 0.0d0
  read(100,*,END=1001) nline
  do i = 1,nline
     read(100,*) stype1, stype2, stype3, stype4, rbuf(1:OPMInter+OPMIntra)
     sptype = typeMap(stype1,stype2)
     sptype2 = typeMap(stype3,stype4)
     if (OPMInter > 0) aMInter(1:OPMInter,sptype,sptype2) = rbuf(1:OPMInter)
     if (OPMIntra > 0) aMIntra(1:OPMIntra,sptype,sptype2) = rbuf(OPMInter+1:OPMInter+OPMIntra)
  enddo
  
  flexAsym = .false.
  ndterm = 0
  read(100,*,END=1001) npterm, nline
  if (nline > 0) then
     flexAsym = .true.
     allocate( p(2,nsitemax,nsitemax,nsitemax,npterm) )
     p(:,:,:,:,:) = 0.0d0
     do i = 1,nline
        read(100,*) index, index2, index3, index4, rbuf(1:npterm)
        do j = 1,npterm
           p(index,index2,index3,index4,j) = rbuf(j)*bohr2A**j
        enddo
     enddo
  endif
  read(100,*,END=1001) nline
  if (nline > 0) then
     flexAsym = .true.
     ndterm = 1
     allocate( D(2,nsitemax,nsitemax,nsitemax,nDisp) )
     D(:,:,:,:,:) = 0.0d0
     do i = 1,nline
        read(100,*) index, index2, index3, index4, rbuf(1:nDisp)
        do j = 1,nDisp
           D(index,index2,index3,index4,j) = rbuf(j)*bohr2A*A2bohr**(cstart + 2*(j-1))
        enddo
     enddo
  endif
1001 continue
  
  close(100)
end subroutine read_fit_gen



end module force_field_gen

